## START: Set by rpmautospec
## (rpmautospec version 0.3.5)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 2;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# simfail runs on bare metal but not on Koji
%bcond_with check

%global toolchain clang

# upstream build system requires the use of libbpf and bpftool sources
# see https://github.com/anakryiko/retsnoop/issues/22
%global bpftool_url https://github.com/libbpf/bpftool
%global bpftool_commit e17d6cf646e1b3107424386a62afc15a36b18f10
%global bpftool_shortcommit %(c=%{bpftool_commit}; echo ${c:0:7})
%global bpftool_date 20230926
%global bpftool_version 7.2.0^%{bpftool_date}git%{bpftool_shortcommit}

%global libbpf_url https://github.com/libbpf/libbpf
%global libbpf_commit 56069cda7897afdd0ae2478825845c7a7308c878
%global libbpf_shortcommit %(c=%{libbpf_commit}; echo ${c:0:7})
%global libbpf_date 20230915
%global libbpf_version 1.2.2^%{libbpf_date}git%{libbpf_shortcommit}

Name:           retsnoop
Version:        0.9.7
Release:        %autorelease
Summary:        A tool for investigating kernel error call stacks

# retsnoop: BSD-2-Clause
# bundled libbpf: LGPL-2.1-only OR BSD-2-Clause
# statically linked rust crates
# taken from %%cargo_license_summary
#
# 0BSD OR MIT OR Apache-2.0
# Apache-2.0 OR MIT
# MIT
# MIT OR Apache-2.0
# MIT OR Zlib OR Apache-2.0
# Unlicense OR MIT
License:        BSD-2-Clause AND (LGPL-2.1-only OR BSD-2-Clause) AND (Apache-2.0 OR MIT) AND MIT AND (0BSD OR Apache-2.0 OR MIT) AND (MIT OR Unlicense) AND (Apache-2.0 OR MIT OR Zlib)
URL:            https://github.com/anakryiko/retsnoop
Source0:        %{url}/archive/v%{version}/%{name}-%{version}.tar.gz
Source1:        %{bpftool_url}/archive/%{bpftool_commit}/bpftool-%{bpftool_version}.tar.gz
Source2:        %{libbpf_url}/archive/%{libbpf_commit}/libbpf-%{libbpf_version}.tar.gz
Source3:        README.Fedora
# vendored dependencies for EPEL
Source100:      %{name}-%{version}-vendor.tar.xz

# bump addr2line, gimli, and object dependencies to the latest versions
Patch0:         0001-bump-addr2line-gimli-and-object-to-latest-versions.patch
# fix regression in 32-bit compilation in 0.9.7
Patch1:         retsnoop-fix-32bit-alignment.diff

# has a Rust component
ExclusiveArch:  %{rust_arches}
# rust syn crate not compiling on 32-bit ARM
ExcludeArch:    armv7hl

BuildRequires:  clang
BuildRequires:  llvm
BuildRequires:  make
%if 0%{?el8}
BuildRequires:  rust-toolset
%else
BuildRequires:  rust-packaging >= 21
%endif
# libbpf deps
BuildRequires:  elfutils-libelf-devel

# upstream does not support dynamic linking
Provides:       bundled(bpftool) = %{bpftool_version}
Provides:       bundled(libbpf) = %{libbpf_version}
# List of bundled crate in vendor tarball, generated with:
# cargo metadata --locked --format-version 1 | CRATE_NAME="retsnoop" ../../bundled-provides.jq
Provides: bundled(crate(addr2line)) = 0.1.0
Provides: bundled(crate(addr2line)) = 0.19.0
Provides: bundled(crate(addr2line)) = 0.21.0
Provides: bundled(crate(adler)) = 1.0.2
Provides: bundled(crate(ansi_term)) = 0.12.1
Provides: bundled(crate(atty)) = 0.2.14
Provides: bundled(crate(backtrace)) = 0.3.69
Provides: bundled(crate(bitflags)) = 1.3.2
Provides: bundled(crate(cc)) = 1.0.83
Provides: bundled(crate(cfg-if)) = 1.0.0
Provides: bundled(crate(clap)) = 2.34.0
Provides: bundled(crate(cpp_demangle)) = 0.4.3
Provides: bundled(crate(crc32fast)) = 1.3.2
Provides: bundled(crate(fallible-iterator)) = 0.2.0
Provides: bundled(crate(findshlibs)) = 0.10.2
Provides: bundled(crate(flate2)) = 1.0.27
Provides: bundled(crate(getopts)) = 0.2.21
Provides: bundled(crate(gimli)) = 0.27.3
Provides: bundled(crate(gimli)) = 0.28.0
Provides: bundled(crate(glob)) = 0.3.1
Provides: bundled(crate(hermit-abi)) = 0.1.19
Provides: bundled(crate(kernel32-sys)) = 0.2.2
Provides: bundled(crate(lazy_static)) = 1.4.0
Provides: bundled(crate(libc)) = 0.2.148
Provides: bundled(crate(memchr)) = 2.6.4
Provides: bundled(crate(memmap)) = 0.7.0
Provides: bundled(crate(miniz_oxide)) = 0.7.1
Provides: bundled(crate(object)) = 0.30.4
Provides: bundled(crate(object)) = 0.32.1
Provides: bundled(crate(rustc-demangle)) = 0.1.23
Provides: bundled(crate(rustc-serialize)) = 0.3.24
Provides: bundled(crate(rustc-test)) = 0.3.1
Provides: bundled(crate(rustc_version)) = 0.2.3
Provides: bundled(crate(semver)) = 0.9.0
Provides: bundled(crate(semver-parser)) = 0.7.0
Provides: bundled(crate(smallvec)) = 1.11.1
Provides: bundled(crate(stable_deref_trait)) = 1.2.0
Provides: bundled(crate(strsim)) = 0.8.0
Provides: bundled(crate(term)) = 0.4.6
Provides: bundled(crate(textwrap)) = 0.11.0
Provides: bundled(crate(time)) = 0.1.45
Provides: bundled(crate(typed-arena)) = 2.0.2
Provides: bundled(crate(unicode-width)) = 0.1.11
Provides: bundled(crate(vec_map)) = 0.8.2
Provides: bundled(crate(wasi)) = 0.10.0+wasi_snapshot_preview1
Provides: bundled(crate(winapi)) = 0.2.8
Provides: bundled(crate(winapi)) = 0.3.9
Provides: bundled(crate(winapi-build)) = 0.1.1
Provides: bundled(crate(winapi-i686-pc-windows-gnu)) = 0.4.0
Provides: bundled(crate(winapi-x86_64-pc-windows-gnu)) = 0.4.0

%description
retsnoop is BPF-based tool that is meant to help debugging kernel issues. It
allows to capture call stacks of kernel functions that return errors (NULL or
-Exxx) and emits every such detected call stack, along with the captured
results.


%prep
%autosetup -p1
# provide the bpftool version we specify rather than using git submodule
tar xf %{SOURCE1}
rmdir bpftool
mv bpftool-%{bpftool_commit} bpftool
# same license files as libbpf, no-op

# provide the libbpf version we specify rather than using git submodule
tar xf %{SOURCE2}
rmdir libbpf
mv libbpf-%{libbpf_commit} libbpf
mv libbpf/LICENSE libbpf-LICENSE
mv libbpf/LICENSE.BSD-2-Clause  libbpf-LICENSE.BSD-2-Clause
mv libbpf/LICENSE.LGPL-2.1 libbpf-LICENSE.LGPL-2.1

# README.Fedora
cp -p %{SOURCE3} .

# Rust parts
# the path is hardcoded, make sure Cargo.toml is found in the expected place
ln -s sidecar/Cargo.toml .
# the checksums in the lock file might not match
rm sidecar/Cargo.lock
%if 0%{?el8}
%cargo_prep -V 100
%else
%cargo_prep

%generate_buildrequires
%cargo_generate_buildrequires
%endif


%build
%if 0%{?fedora} < 36
# this is only called automatically after
# https://www.fedoraproject.org/wiki/Changes/SetBuildFlagsBuildCheck
%set_build_flags
%endif
cd sidecar
%cargo_build
cd -
%if 0%{?el8}
%make_build -C src CC=clang HOSTCC=clang V=1 VERBOSE=1
%else
%make_build -C src HOSTCC=clang
%endif


%install
%make_install -C src prefix=%{_prefix}


%if %{with check}
%check
./src/simfail -a
%endif


%files
%license LICENSE libbpf-LICENSE*
%doc README.md TODO.md README.Fedora
%{_bindir}/retsnoop
%{_bindir}/simfail


%changelog
* Mon Oct 02 2023 Michel Lind <salimma@fedoraproject.org> - 0.9.7-2
- Fix 32-bit builds

* Mon Oct 02 2023 Michel Lind <salimma@fedoraproject.org> - 0.9.7-1
- Update to 0.9.7

* Tue Apr 18 2023 Michel Alexandre Salim <salimma@fedoraproject.org> - 0.9.6-1
- Update to 0.9.6; Fixes: RHBZ#2181684

* Thu Feb 16 2023 Michel Alexandre Salim <salimma@fedoraproject.org> - 0.9.5-1
- Update to 0.9.5

* Tue Feb 07 2023 Michel Alexandre Salim <salimma@fedoraproject.org> - 0.9.4-2
- Update vendored dependencies
- also generate bundled provides (courtesy of zincati's bundled-
  provides.jq)

* Tue Feb 07 2023 Michel Alexandre Salim <salimma@fedoraproject.org> - 0.9.4-1
- Update to 0.9.4

* Tue Feb 07 2023 Michel Alexandre Salim <salimma@fedoraproject.org> - 0.9.3-2
- Explicitly require llvm

* Tue Nov 08 2022 Michel Alexandre Salim <salimma@fedoraproject.org> - 0.9.3-1
- Update to 0.9.3; this adds KASLR support Document installing `kernel-
  debuginfo` for better tracing

* Wed Oct 26 2022 Michel Alexandre Salim <salimma@fedoraproject.org> - 0.9.2-3
- use vendored crates on EPEL 8

* Wed Oct 26 2022 Michel Alexandre Salim <salimma@fedoraproject.org> - 0.9.2-2
- Actually copy in README.Fedora so it can be used

* Wed Oct 26 2022 Michel Alexandre Salim <salimma@fedoraproject.org> - 0.9.2-1
- Initial Fedora release
